////////////////////////////////////////////////////////////////////////////////
// sudokuki - C++ graphical sudoku game                                       //
// Copyright (C) 2007-2009 Sylvain Vedrenne                                   //
//                                                                            //
// This program is free software; you can redistribute it and/or              //
// modify it under the terms of the GNU General Public License                //
// as published by the Free Software Foundation; either version 2             //
// of the License, or (at your option) any later version.                     //
//                                                                            //
// This program is distributed in the hope that it will be useful,            //
// but WITHOUT ANY WARRANTY; without even the implied warranty of             //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              //
// GNU General Public License for more details.                               //
//                                                                            //
// You should have received a copy of the GNU General Public License along    //
// with this program; if not, write to the Free Software Foundation, Inc.,    //
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.              //
////////////////////////////////////////////////////////////////////////////////
#ifndef _HH_SOLVER_HH_
#define _HH_SOLVER_HH_

#include <iostream>
#include <assert.h>
#include <map>
#include "grid_tool.hh"

using namespace std;

class solver : virtual public grid_tool {
	friend class tst_solver;

public:
	solver() {
//		printf("[%s/%s]%s\n", __FILE__, __func__, "");
	};
	virtual ~solver() {
//		printf("[%s/%s]%s\n", __FILE__, __func__, "");
	};
	int resolve( void );
	std::map<int, int> get_current_grid_values();
	int get_cell_value( int li, int co );

private:
//	int dummy() { return 1;}
};

#endif //_HH_SOLVER_HH_
